public inbox for libc-alpha@sourceware.org
 help / color / mirror / Atom feed
From: Adhemerval Zanella <adhemerval.zanella@linaro.org>
To: libc-alpha@sourceware.org
Cc: Paul Eggert <eggert@cs.ucla.edu>
Subject: [PATCH 9/9] posix: Fix glob with GLOB_NOCHECK returning modified patterns (BZ#10246)
Date: Tue, 05 Sep 2017 20:25:00 -0000	[thread overview]
Message-ID: <1504643122-14874-10-git-send-email-adhemerval.zanella@linaro.org> (raw)
In-Reply-To: <1504643122-14874-1-git-send-email-adhemerval.zanella@linaro.org>

According to POSIX glob with GLOB_NOCHECK should return a list consisting
of only of the input pattern in case of no match.  However GLIBC does not
honor in case of '//<something'.  This is due internally this is handled
and special case and prefix_array (responsable to prepend the directory
name) does not know if the input already contains a slash or not since
either '/<something>' or '//<something>' will be handle in same way.

This patch fix it by using a empty directory name for the latter (since
prefix_array already adds a slash as default for each entry).

Checked on x86_64-linux-gnu and on a build using build-many-glibcs.py
for all major architectures.

	[BZ #10246]
	* posix/glob.c (glob): Handle pattern that do not match and
	start with '/' correctly.
	* posix/globtest.sh: New tests for NOCHECK.
---
 ChangeLog         |  7 ++++++-
 posix/glob.c      | 13 +++++++------
 posix/globtest.sh | 37 +++++++++++++++++++++++++++++++++++++
 3 files changed, 50 insertions(+), 7 deletions(-)

diff --git a/posix/glob.c b/posix/glob.c
index 30a4143..25c5d24 100644
--- a/posix/glob.c
+++ b/posix/glob.c
@@ -272,6 +272,8 @@ glob (const char *pattern, int flags, int (*errfunc) (const char *, int),
   size_t oldcount;
   int meta;
   int dirname_modified;
+  /* Indicate if the directory should be prepended on return values.  */
+  bool dirname_prefix = true;
   int malloc_dirname = 0;
   glob_t dirs;
   int retval = 0;
@@ -495,6 +497,10 @@ glob (const char *pattern, int flags, int (*errfunc) (const char *, int),
       dirname = (char *) "/";
       dirlen = 1;
       ++filename;
+      /* prefix_array adds a separator for each result and DIRNAME is
+	 already '/'.  So we indicate later that we should not prepend
+	 anything for this specific case.  */
+      dirname_prefix = false;
     }
   else
     {
@@ -1086,7 +1092,7 @@ glob (const char *pattern, int flags, int (*errfunc) (const char *, int),
       if (dirlen > 0)
 	{
 	  /* Stick the directory on the front of each name.  */
-	  if (prefix_array (dirname,
+	  if (prefix_array (dirname_prefix ? dirname : "",
 			    &pglob->gl_pathv[old_pathc + pglob->gl_offs],
 			    pglob->gl_pathc - old_pathc))
 	    {
@@ -1167,11 +1173,6 @@ prefix_array (const char *dirname, char **array, size_t n)
   size_t dirlen = strlen (dirname);
   char dirsep_char = '/';
 
-  if (dirlen == 1 && dirname[0] == '/')
-    /* DIRNAME is just "/", so normal prepending would get us "//foo".
-       We want "/foo" instead, so don't prepend any chars from DIRNAME.  */
-    dirlen = 0;
-
 #if defined __MSDOS__ || defined WINDOWS32
   if (dirlen > 1)
     {
diff --git a/posix/globtest.sh b/posix/globtest.sh
index 73f7ae3..92a8e37 100755
--- a/posix/globtest.sh
+++ b/posix/globtest.sh
@@ -242,6 +242,43 @@ if test $failed -ne 0; then
   result=1
 fi
 
+# Test NOCHECK for specific cases where the pattern used starts
+# with '/' (BZ#10246).
+failed=0
+${test_program_prefix} \
+${common_objpfx}posix/globtest -c "$testdir" "/%" |
+sort > $testout
+cat <<"EOF" | $CMP - $testout >> $logfile || failed=1
+`/%'
+EOF
+if test $failed -ne 0; then
+  echo "No check test failed" >> $logfile
+  result=1
+fi
+
+${test_program_prefix} \
+${common_objpfx}posix/globtest -c "$testdir" "//%" |
+sort > $testout
+cat <<"EOF" | $CMP - $testout >> $logfile || failed=1
+`//%'
+EOF
+if test $failed -ne 0; then
+  echo "No check test failed" >> $logfile
+  result=1
+fi
+
+${test_program_prefix} \
+${common_objpfx}posix/globtest -c "$testdir" "///%" |
+sort > $testout
+cat <<"EOF" | $CMP - $testout >> $logfile || failed=1
+`///%'
+EOF
+if test $failed -ne 0; then
+  echo "No check test failed" >> $logfile
+  result=1
+fi
+
+
 # Test NOMAGIC without magic characters
 failed=0
 ${test_program_prefix} \
-- 
2.7.4

  parent reply	other threads:[~2017-09-05 20:25 UTC|newest]

Thread overview: 62+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-09-05 20:25 [PATCH 0/9] posix: glob fixes and refactor Adhemerval Zanella
2017-09-05 20:25 ` [PATCH 3/9] posix: Allow glob to match dangling symlinks [BZ #866] Adhemerval Zanella
2017-09-06  1:27   ` Paul Eggert
2017-09-06 12:57     ` Adhemerval Zanella
2017-09-09  9:50   ` Andreas Schwab
2017-09-09 11:56     ` Adhemerval Zanella
2017-09-09 17:02       ` Paul Eggert
2017-09-09 17:11         ` Zack Weinberg
2017-09-09 17:26           ` Andreas Schwab
2017-09-09 17:33             ` Zack Weinberg
2017-09-10  8:19         ` Adhemerval Zanella
2017-09-10 17:13           ` Paul Eggert
2017-09-11 14:34           ` Joseph Myers
2017-09-11 14:38             ` Zack Weinberg
2017-09-11 16:53               ` Paul Eggert
2017-09-11 17:25                 ` Zack Weinberg
2017-09-11 17:38                   ` Paul Eggert
2017-09-11 17:56                     ` Zack Weinberg
2017-09-11 18:03                       ` Paul Eggert
2017-09-11 20:09                         ` Adhemerval Zanella
2017-09-13  9:14                           ` Paul Eggert
2017-09-13 12:22                             ` Adhemerval Zanella
2017-09-14 10:05                               ` Szabolcs Nagy
2017-09-14 13:43                                 ` Adhemerval Zanella
2017-09-15 20:18                             ` Florian Weimer
2017-09-15 20:27                               ` Adhemerval Zanella
2017-09-17  7:16                               ` Paul Eggert
2017-09-17  7:48                                 ` Florian Weimer
2017-09-17 14:18                                   ` Adhemerval Zanella
2017-09-05 20:25 ` [PATCH 6/9] posix: fix glob bugs with long login names Adhemerval Zanella
2017-09-05 20:25 ` Adhemerval Zanella [this message]
2017-09-07 22:14   ` [PATCH 9/9] posix: Fix glob with GLOB_NOCHECK returning modified patterns (BZ#10246) Paul Eggert
2017-09-08  9:16     ` Adhemerval Zanella
2017-09-05 20:25 ` [PATCH 5/9] posix: Fix getpwnam_r usage (BZ #1062) Adhemerval Zanella
2017-09-05 20:25 ` [PATCH 4/9] Sync scratch_buffer with gnulib Adhemerval Zanella
2017-09-18  6:09   ` Florian Weimer
2017-09-18 11:43     ` Adhemerval Zanella
2017-09-18 11:57       ` Florian Weimer
2017-09-18 12:25         ` Adhemerval Zanella
2017-09-05 20:25 ` [PATCH 8/9] posix: Use enum for __glob_pattern_type result Adhemerval Zanella
2017-09-06  1:30   ` Paul Eggert
2017-09-06  4:18   ` Paul Eggert
2017-09-06 13:04     ` Adhemerval Zanella
2017-09-06 16:18       ` Paul Eggert
2017-09-06 16:54         ` Adhemerval Zanella
2017-09-05 20:25 ` [PATCH 7/9] posix: Consolidate glob implementation Adhemerval Zanella
2017-09-12  7:35   ` Andreas Schwab
2017-09-12 14:08     ` Adhemerval Zanella
2017-09-12 14:17       ` Andreas Schwab
2017-09-12 14:29     ` Joseph Myers
2017-09-12 14:39       ` Andreas Schwab
2017-09-12 14:50         ` Joseph Myers
2017-09-12 12:56   ` Andreas Schwab
2017-09-12 14:22     ` Adhemerval Zanella
2017-09-12 14:34       ` Andreas Schwab
2017-09-13 12:26         ` Adhemerval Zanella
2017-09-05 20:25 ` [PATCH 1/9] posix: Sync glob with gnulib [BZ #1062] Adhemerval Zanella
2017-09-06  2:01   ` Paul Eggert
2017-09-06 12:52     ` Adhemerval Zanella
2017-09-12 14:20   ` Andreas Schwab
2017-09-12 17:06     ` Adhemerval Zanella
2017-09-05 20:25 ` [PATCH 2/9] posix: accept inode 0 is a valid inode number (BZ #19971) Adhemerval Zanella

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1504643122-14874-10-git-send-email-adhemerval.zanella@linaro.org \
    --to=adhemerval.zanella@linaro.org \
    --cc=eggert@cs.ucla.edu \
    --cc=libc-alpha@sourceware.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).